// https://codeforces.com/problemset/problem/369/E
#include <iostream>
#include <algorithm>
using namespace std;

using ll = long long;
const ll N = 1e6 + 5;

ll ans[N];

struct Segm {
	ll x, y;
	ll q;    // query
} s[N];

struct BIT {
	ll a[N];
	void Update(ll x,ll v)
	{
		for (; x < N; x += x & -x)
			a[x] += v;
	}
	
	ll QuerySum(ll x)   // nr de intervale pana la poz x care nu contin nici un punct
	{
		ll y = 0;
		for (; x; x -= x & -x)
			y += a[x];
		return y;
	}
} b;

int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);cout.tie(0);
	
	ll n, m, cnt, x, y, k = 0;
	cin >> n >> m;
	for (int i = 0; i < n; ++i)
	{
		cin >> x >> y;
		s[k++] = {x, y, 0};
	}
	
	for (int i = 1; i <= m; ++i)
	{
		cin >> cnt;
		for (x = 0; cnt--; x = y)
		{
			cin >> y;
			s[k++] = {x + 1, y - 1, i}; // adauga un segment care nu contine punctul query-ului curent
		}
		
		s[k++] = {x + 1, N - 1, i};
	}
	
	sort(s, s + k, [](Segm const& a, Segm const& b) {
	/*	if (a.x > b.x) return true;                              // descrescator dupa capatul din stanga
		if (a.x == b.x && a.y < b.y) return true;                // crescator dupa capatul din dreapta 
		if (a.x == b.x && a.y == b.y && a.q < y.q) return true;  // crescator dupa query (mai intai vrem update, apoi query)
		return false;
	*/	
		return a.x != b.x ? a.x > b.x : (a.y != b.y ? a.y < b.y : a.q < b.q);
	});
	
	for (int i = 0; i < k; ++i)
		if (s[i].q)
			ans[s[i].q] += b.QuerySum(s[i].y); // adauga nr de intervale date din interiorul segmentului [s[i].x, s[i].y] 
		else                                   // - in stanga de s[i].x nu avem valori de 1
			b.Update(s[i].y, 1);
	
	// pt fiecare query, scadem din nr total de intervale date, nr de intervale care nu contin nici un punct
	for (int i = 1; i <= m; ++i)
		cout << n - ans[i] << '\n';
}
