// https://www.spoj.com/problems/INCSEQ/
// the number of increasing subsequences with length K
#include <iostream>
using namespace std;
const int mod = 5000000;
const int VALMAX = 100005;
int aib[55][100005], x, n, K, res;
// aib[k][x] = numarul de subsiruri cresc care se temina cu valoarea x (poz) si au lungimea fix k

inline void Update(int k, int x, int val)
{
	for (int i = x; i <= VALMAX; i += i & -i)
	{
		aib[k][i] += val;
		if (aib[k][i] > mod)
			aib[k][i] -= mod;
	}
}

inline int Query(int k, int x) // nr de subsiruri care se termina cu valoarea x si au lungimea k
{
	int s = 0;
	for (int i = x; i > 0; i -= i & -i)
	{
		s += aib[k][i];
		if (s > mod)
			s -= mod;
	}
	return s;
}

int main()
{
	cin >> n >> K;
	for (int i = 1; i <= n; ++i)
	{
		cin >> x;
		Update(1, x, 1);
		for (int k = 2; k <= K; ++k)
		{
			int nr = Query(k - 1, x - 1); // nr de subs strict cresc
			                              // care au lung fix k - 1 si
                                          // se termina cu valori < x
			Update(k, x, nr);
		}
	}
	cout << Query(K, VALMAX);
	return 0;
}

