// https://www.spoj.com/problems/INCSEQ/
// the number of increasing subsequences with length K 
#include <iostream>
using namespace std;
const int mod = 5000000;

int dp[55][10005], v[10005], n, K, res;
// dp[k][i] = nr subsiruri crescatoare care se termina cu v[i] si au k elemente

int main()
{
	cin >> n >> K;
	for (int i = 1; i <= n; ++i)
		cin >> v[i];

	// O(n * n * K)
	for (int i = 1; i <= n; ++i)
	{
		dp[1][i] = 1;   // nr subs de lung 1 care se termina cu v[i] = 1
		for (int j = 1; j < i; ++j)
			if (v[j] < v[i])
				for (int k = 2; k <= K; ++k)
				{
					dp[k][i] += dp[k - 1][j];
					if (dp[k][i] > mod)
						dp[k][i] -= mod;
				}
	}
	
	for (int i = K; i <= n; ++i)
	{
		res += dp[K][i];
		if (res > mod)
			res -= mod;
	}
	cout << res;     // totalul subsirurilor de lung K care se termina pe orice pozitie >= K
	return 0;
}

