// accepted
// https://www.spoj.com/problems/INCSEQ/
// the number of increasing subsequences with length K 
#include <algorithm>
#include <iostream>
#include <map>
using namespace std;

const int K = 52, Mod = 5000000, MaxVal = 100048, Dim = 10001;

int aib[K][Dim];     // aib[k][v] = nr de subsiruri crescatoare de lungime k, care se termina cu valoarea v         
int a[Dim];          // sirul v[] sortat 
int V = 0;           // valoarea maxima a unui elem din sir, dupa normalizare

int Query(int k, int x)
{
    int sum = 0;
    for (int i = x; i; i -= i & -i) 
    {
		sum += aib[k][i];
		if (sum >= Mod) 
			sum -= Mod;
	}
    return sum;
}

void Update(int k, int x, int v)
{
    for (int i = x; i <= V; i += i & -i) 
    {
		aib[k][i] += v;
		if (aib[k][i] >= Mod) 
			aib[k][i] -= Mod;
	}
}

int main()
{
    int K, N;
    cin >> N >> K;
    
    map<int, int> mp;
	for (int i = 0; i < N; ++i)
	{
		cin >> a[i];
		mp[a[i]];      // creaza un nou pair <a[i], 0>  daca nu exista cheia a[i]
	}

	for (auto [key, val] : mp)
		mp[key] = ++V;
		
    //  O(N * K * log(N)) 
    for (int i = 0; i < N; ++i)
    {
        int x = mp[a[i]];  // x = noua valoare a lui a[i]
        
        Update(1, x, 1);   // Cu oricare numar poate incepe un sir crescator
       
        for (int k = 2; k <= K; ++k)
        {
            int cnt = Query(k - 1, x - 1);   // Oricare subsir crescator de lungime k - 1 cu ultima valoare mai mica decat x 
            if (cnt)
				Update(k, x, cnt);         // poate fi extins la un subsir de lungime k cu ultimul element x
		}
    }
    
    cout <<  Query(K, V) << '\n';
    return 0;
}
